package sun.security.krb5.internal;

import sun.security.util.DerInputStream;
import java.io.IOException;
import sun.security.util.DerValue;
import sun.security.krb5.Asn1Exception;
import sun.security.krb5.internal.util.KerberosFlags;

public class APOptions extends KerberosFlags
{
    public APOptions() {
        super(32);
    }
    
    public APOptions(int index) throws Asn1Exception {
        super(32);
        this.set(index, true);
    }
    
    public APOptions(int length, byte[] a) throws Asn1Exception {
        super(length, a);
        if (length > a.length * 8 || length > 32) {
            throw new Asn1Exception(502);
        }
        return;
    }
    
    public APOptions(boolean[] bools) throws Asn1Exception {
        super(bools);
        if (bools.length > 32) {
            throw new Asn1Exception(502);
        }
        return;
    }
    
    public APOptions(DerValue derValue) throws IOException, Asn1Exception {
        this(derValue.getUnalignedBitString(true).toBooleanArray());
    }
    
    public static APOptions parse(DerInputStream derInputStream, byte b, boolean b2) throws Asn1Exception, IOException {
        if (b2 && ((byte)derInputStream.peekByte() & 0x1F) != b) {
            return null;
        }
        DerValue derValue = derInputStream.getDerValue();
        if (b != (derValue.getTag() & 0x1F)) {
            throw new Asn1Exception(906);
        }
        return new APOptions(derValue.getData().getDerValue());
    }
}
